#include <string.h>

#include "module.h"

moduleentry_t availmodules[] = {
    (moduleentry_t) { .name = "mod_tidy", .module = { .init = mod_tidy_init } },
    //(moduleentry_t) { .name = "mod_debug", .module = { .init = mod_debug_init } },
    (moduleentry_t) { .name = "mod_pagedata", .module = { .init = mod_pagedata_init } },
    (moduleentry_t) { .name = "mod_parse", .module = { .init = mod_parse_init } },
    (moduleentry_t) { .name = "mod_robots", .module = { .init = mod_robots_init } },
    { 0 },
};

requestedreq_dyanrr_t requestedreqs = { 0 };

void *searchextradata(extradata_type_t type, char *key, extradata_t *data, size_t ndata) {
    for (size_t i = 0; i < ndata; i++)
        if (data[i].type == type && strcmp(data[i].key, key) == 0)
            return data[i].val;
    return NULL;
}

void makerequest(const char *url, reqcb_t cb, void *userdata) {
    if (requestedreqs.data == NULL)
        dynarr_init(requestedreq_dyanrr_t, requestedreqs);
    requestedreq_t request = { .url = url, .cb = cb, .userdata = userdata, 0 };
    dynarr_push(requestedreqs, request);
}
